using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Threading;

namespace Decal.Interop.DHS;

internal sealed class _IHotkeySystemEvents_EventProvider : _IHotkeySystemEvents_Event, IDisposable
{
	private IConnectionPointContainer m_ConnectionPointContainer;

	private ArrayList m_aEventSinkHelpers;

	private IConnectionPoint m_ConnectionPoint;

	private void Init()
	{
		IConnectionPoint ppCP = null;
		Guid riid = new Guid(new byte[16]
		{
			224, 1, 24, 181, 175, 116, 22, 73, 171, 15,
			224, 107, 9, 86, 124, 60
		});
		m_ConnectionPointContainer.FindConnectionPoint(ref riid, out ppCP);
		m_ConnectionPoint = ppCP;
		m_aEventSinkHelpers = new ArrayList();
	}

	event _IHotkeySystemEvents_HotkeyEventEventHandler _IHotkeySystemEvents_Event.HotkeyEvent
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				_IHotkeySystemEvents_SinkHelper iHotkeySystemEvents_SinkHelper = new _IHotkeySystemEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(iHotkeySystemEvents_SinkHelper, out pdwCookie);
				iHotkeySystemEvents_SinkHelper.m_dwCookie = pdwCookie;
				iHotkeySystemEvents_SinkHelper.m_HotkeyEventDelegate = value;
				m_aEventSinkHelpers.Add(iHotkeySystemEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					_IHotkeySystemEvents_SinkHelper iHotkeySystemEvents_SinkHelper = (_IHotkeySystemEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (iHotkeySystemEvents_SinkHelper.m_HotkeyEventDelegate != null && ((iHotkeySystemEvents_SinkHelper.m_HotkeyEventDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(iHotkeySystemEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	public _IHotkeySystemEvents_EventProvider(object P_0)
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		m_ConnectionPointContainer = (IConnectionPointContainer)P_0;
	}

	public void Finalize()
	{
		bool lockTaken = default(bool);
		try
		{
			Monitor.Enter(this, ref lockTaken);
			if (m_ConnectionPoint == null)
			{
				return;
			}
			int count = m_aEventSinkHelpers.Count;
			int num = 0;
			if (0 < count)
			{
				do
				{
					_IHotkeySystemEvents_SinkHelper iHotkeySystemEvents_SinkHelper = (_IHotkeySystemEvents_SinkHelper)m_aEventSinkHelpers[num];
					m_ConnectionPoint.Unadvise(iHotkeySystemEvents_SinkHelper.m_dwCookie);
					num++;
				}
				while (num < count);
			}
			Marshal.ReleaseComObject(m_ConnectionPoint);
		}
		catch (Exception)
		{
		}
		finally
		{
			if (lockTaken)
			{
				Monitor.Exit(this);
			}
		}
	}

	public void Dispose()
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		Finalize();
		GC.SuppressFinalize(this);
	}
}
